import java.awt.*;
import java.applet.*;
import java.util.Date;
import java.net.*;

public class TestDrive extends Applet implements Runnable{
    int height;
    int width;
    Button button1, button2, button3, button4;
    Color backgroundColor=getBackground();
    Thread animThread;
    Image offScreenImage;
    Graphics offScreen;
    URL codeBase;
    Z28 z28;
    boolean firstTime=true;

    public void init(){
        if(getParameter("backgroundcolor")!=null) backgroundColor=decodeColor(getParameter("backgroundColor"));
        else backgroundColor=Color.white;
        Dimension d=this.size();
        height=d.height;
        width=d.width;
        codeBase=getCodeBase();
        z28=new Z28(this);
		z28.start();
        button1 = new Button("Start it up");
        add(button1);
        button2 = new Button("Rev it up");
        add(button2);
        button3 = new Button("Burnout");
        add(button3);
        button4 = new Button("Turn it off");
        add(button4);

        offScreenImage=this.createImage(width,height);
        offScreen=offScreenImage.getGraphics();
    }

    public void start(){
        if(!firstTime){
            z28=new Z28(this);
			z28.start();
        }
        firstTime=false;
        animThread=new Thread(this);
        animThread.start();
    }

    public void stop(){
        animThread.stop();
        z28.stopApp();
    }

    public void update(Graphics g){
        paint(g);
    }

    public void paint(Graphics g){
        offScreen.setColor(backgroundColor);
        offScreen.fillRect(0, 0,width,height);
        if(z28.getStatus()){
            z28.paint(offScreen);
        }
        else{
            offScreen.setColor(Color.red);
            if(!(z28.getImageStatus().equals("finished")))offScreen.drawString("Loading image files...",10,height/4);
            if(!(z28.getSoundStatus().equals("finished"))) offScreen.drawString("Loading sound files...",10,height/4+15);
            if(z28.getImageStatus().equals("finished")) z28.paint(offScreen);
        }
        g.drawImage(offScreenImage,0,0,this);

    }

    public int getWidth(){
        return width;
    }

    public int getHeight(){
        return height;
    }

    public void run(){
        while(true){
            while(z28.getStatus()){
                z28.moveCar();
                repaint();
                try{animThread.sleep(33);}
                catch (InterruptedException e){}
            }
            try{animThread.sleep(200);}
            catch (InterruptedException e){}
        }
    }

    public boolean action(Event evt, Object arg){
        if (evt.target instanceof Button)
            HandleButtons(arg);
        return true;
    }
    public void HandleButtons(Object label){
        if(label=="Start it up"){
            if(z28.getStatus()) z28.startEngine();
        }
        if(label=="Rev it up"){
            if(z28.getStatus()) z28.revEngine();
        }
        if(label=="Burnout"){
            if(z28.getStatus()) z28.burnout();
        }
        if(label=="Turn it off"){
            if(z28.getStatus()) z28.stopEngine();
        }
    }

    public Color getBackgroundColor(){
        return backgroundColor;
    }

   private Color decodeColor(String s){
        int n=0;
        try{
            if(s.startsWith("0x")) n=Integer.parseInt(s.substring(2),16);
            else if(s.startsWith("#")) n=Integer.parseInt(s.substring(1),16);
            else if (s.startsWith("0") && s.length()> 1) n=Integer.parseInt(s.substring(1),8);
            else n=Integer.parseInt(s, 10);
            return new Color(n);
        }
        catch(NumberFormatException e){return null;}
    }
}
