import java.awt.*;
import java.applet.*;
import java.util.Date;
import java.net.*;

public class Z28 extends Thread{
    boolean moving=false;
    boolean engineOn=false;
    boolean accelerate=false;
    boolean decelerate=false;
    AudioThread audioThread;
    double move=1;
    double acceleration=.20;
    double deceleration=.12;
    int locX,locY;
    double startPos,appletWidth,appletHeight;
    int numWheelPics=4;
    int numSmokePics=2;
    int numFrames=4;
    int offScreenDelay=3500;
    int animationDelay=1500;
    MediaTracker tracker;
    URL codeBase;

    Image frames1[];
    Image frames2[];
    Image wheelPic[];
    Image smokePic[];
    Image carPic;
    Graphics offScreen;

    byte countWheel=0;
    byte countSmoke=0;
    byte countFrame=0;
    int frontWheelXOffset=39;
    int frontWheelYOffset=50;
    int backWheelXOffset=205;
    int backWheelYOffset=50;
    int smokeXOffset=236;
    int smokeYOffset=38;
    int frameHeight;
    int frameWidth;
    TestDrive applet;
    String loading="";
    Color backgroundColor;
    long waitFor=System.currentTimeMillis()*2;

    public Z28(TestDrive applet){
        backgroundColor=applet.getBackgroundColor();
        this.applet=applet;
        setParameters();
        this.codeBase=applet.getCodeBase();
        tracker=new MediaTracker(applet);
        frames1=new Image[numFrames];
        frames2=new Image[numFrames];
        this.appletWidth=applet.getWidth();
        this.appletHeight=applet.getHeight();
		audioThread=new AudioThread(this,codeBase,applet);
		audioThread.start();
    }

    public void paint(Graphics g){
        if(moving&&accelerate){
            g.drawImage(frames1[countFrame],locX,locY,applet);
        }
        else if(moving&&decelerate){
            g.drawImage(frames2[countFrame],locX,locY,applet);
        }
        else g.drawImage(carPic,locX,locY,applet);
    }

    public void run(){
        loading="main";
        carPic=applet.getImage(codeBase, "car0.jpg");
        tracker.addImage(carPic,1);

        wheelPic=new Image[numWheelPics];
        for(int k=0; k<numWheelPics; k++){
            wheelPic[k]=applet.getImage(codeBase, "wheel" + String.valueOf(k) + ".gif");
            tracker.addImage(wheelPic[k],0);
        }

        smokePic=new Image[numSmokePics];
        for(int k=0; k<numSmokePics; k++){
            smokePic[k]=applet.getImage(codeBase, "smoke" + String.valueOf(k) + ".gif");
            tracker.addImage(smokePic[k],0);
        }
        try{tracker.waitForID(1);}
        catch (InterruptedException e){}
        loading="secondary";
        try{tracker.waitForID(0);}
        catch (InterruptedException e){}
        setFrameSize();
        for(int k=0;k<numFrames;k++){
            //Animation frames for burnout
            frames1[k]=applet.createImage(frameWidth,frameHeight);
            offScreen=frames1[k].getGraphics();
            offScreen.setColor(backgroundColor);
            offScreen.fillRect(0,0,frameWidth,frameHeight);
            offScreen.drawImage(carPic,0,0,applet);
            offScreen.drawImage(wheelPic[countWheel],frontWheelXOffset,frontWheelYOffset,applet);
            offScreen.drawImage(smokePic[countSmoke],smokeXOffset,smokeYOffset,applet);
            offScreen.drawImage(wheelPic[countWheel],backWheelXOffset,backWheelYOffset,applet);
            //Animation frames for rolling normal
            frames2[k]=applet.createImage(306,98);
            offScreen=frames2[k].getGraphics();
            offScreen.setColor(backgroundColor);
            offScreen.fillRect(0,0,frameWidth,frameHeight);
            offScreen.drawImage(carPic,0,0,applet);
            offScreen.drawImage(wheelPic[countWheel],frontWheelXOffset,frontWheelYOffset,applet);
            offScreen.drawImage(wheelPic[countWheel],backWheelXOffset,backWheelYOffset,applet);
            countWheel++;
            countSmoke++;
            if(countWheel==numWheelPics) countWheel=0;
            if(countSmoke==numSmokePics) countSmoke=0;
        }
        loading="finished";
        startPos=(double)(appletWidth/2-frameWidth/2);
        locX=(int)startPos;
        locY=(int)(appletHeight-(frameHeight+10));
        while(true){
            if(System.currentTimeMillis()>waitFor){
                moving=true;
                waitFor=System.currentTimeMillis()*2;
            }
            try{this.sleep(100);}
            catch(Exception e){}
        }
    }

    public void startEngine(){
        if(!engineOn){
            engineOn=true;
            audioThread.startup();
        }
    }
    public void revEngine(){
        if(engineOn&&!moving){
            audioThread.rev();
        }
    }
    public void burnout(){
        if(engineOn&&!moving){
            waitFor=System.currentTimeMillis()+animationDelay;
            accelerate=true;
            audioThread.burnout();
        }
    }
    public void stopEngine(){
        engineOn=false;
        audioThread.stopIdle();
    }

    public void moveCar(){
        if(moving){
            countFrame++;
            if(countFrame==numFrames-1) countFrame=0;
            if(accelerate){
                locX=(int)(startPos-move);
                move+=move*acceleration;
                if(move>frameWidth+appletWidth){
                    locX=(int)(startPos+move);
                    accelerate=false;
                    decelerate=true;
                    moving=false;
                    waitFor=System.currentTimeMillis()+offScreenDelay;
                }
            }
            else if(decelerate){
                locX=(int)(startPos+move);
                move-=move*deceleration;
                if(move<1){
                    moving=false;
                    decelerate=false;
                    locX=(int)startPos;
                    move=1;
                }
            }
        }
    }

    public boolean getEngineOn(){
        return engineOn;
    }

    public boolean getStatus(){
        if(!(getImageStatus().equals("finished"))) return false;
        if(!(audioThread.getSoundStatus().equals("finished"))) return false;
        else return true;
    }

    public String getSoundStatus(){
        return audioThread.getSoundStatus();
    }

    public String getImageStatus(){
        return loading;
    }

    public void stopApp(){
        this.stop();
        audioThread.stop();
        audioThread.stopIdle();
    }

    private void setParameters(){
    	if(applet.getParameter("numWheelPics")!=null) numWheelPics=Integer.parseInt(applet.getParameter("numWheelPics"));
    	if(applet.getParameter("numSmokePics")!=null) numSmokePics=Integer.parseInt(applet.getParameter("numSmokePics"));
    	if(applet.getParameter("numFrames")!=null) numFrames=Integer.parseInt(applet.getParameter("numFrames"));
    	if(applet.getParameter("frontWheelXOffset")!=null) frontWheelXOffset=Integer.parseInt(applet.getParameter("frontWheelXOffset"));
    	if(applet.getParameter("frontWheelYOffset")!=null) frontWheelYOffset=Integer.parseInt(applet.getParameter("frontWheelYOffset"));
    	if(applet.getParameter("backWheelXOffset")!=null) backWheelXOffset=Integer.parseInt(applet.getParameter("backWheelXOffset"));
    	if(applet.getParameter("backWheelYOffset")!=null) backWheelYOffset=Integer.parseInt(applet.getParameter("backWheelYOffset"));
    	if(applet.getParameter("smokeXOffset")!=null) smokeXOffset=Integer.parseInt(applet.getParameter("smokeXOffset"));
    	if(applet.getParameter("smokeYOffset")!=null) smokeYOffset=Integer.parseInt(applet.getParameter("smokeYOffset"));
    	if(applet.getParameter("acceleration")!=null) acceleration=Double.valueOf(applet.getParameter("acceleration")).doubleValue();
    	if(applet.getParameter("deceleration")!=null) deceleration=Double.valueOf(applet.getParameter("deceleration")).doubleValue();
    	if(applet.getParameter("offScreenDelay")!=null) offScreenDelay=Integer.parseInt(applet.getParameter("offScreenDelay"));
    	if(applet.getParameter("animationDelay")!=null) animationDelay=Integer.parseInt(applet.getParameter("animationDelay"));

    }

    private void setFrameSize(){
        int h,w;
        frameHeight=carPic.getHeight(applet);
        frameWidth=carPic.getWidth(applet);
        if((h=smokeYOffset+smokePic[0].getHeight(applet))>frameHeight) frameHeight=h;
        if((w=smokeXOffset+smokePic[0].getWidth(applet))>frameWidth) frameWidth=w;
    }
}

class AudioThread extends Thread{
    private AudioClip idleSound, revSound, burnoutSound, startupSound;
    private Z28 z28;
    private URL codeBase;
    private Applet applet;
    private boolean playIdle=false;
    private long waitFor=System.currentTimeMillis()*2;
    private String loading="";
    private int burnoutSoundLength=6100;
    private int idleSoundLength=1000;
    private int revSoundLength=4000;
    private int startupSoundLength=2700;

    public AudioThread(Z28 z28,URL codeBase,Applet applet){
        this.z28=z28;
        this.codeBase=codeBase;
        this.applet=applet;
        setParameters();
    }

    public void stopIdle(int wait){
        playIdle=false;
        idleSound.stop();
        waitFor=System.currentTimeMillis()+wait;
    }

    public void stopIdle(){
        playIdle=false;
        idleSound.stop();
    }

    public void startIdle(){
        playIdle=true;
    }

    public void rev(){
        stopIdle(revSoundLength-200);
        revSound.play();
    }

    public void burnout(){
        stopIdle(burnoutSoundLength);
        burnoutSound.play();
    }

    public void startup(){
        startupSound.play();
        startIdle();
        stopIdle(startupSoundLength-200);
    }

    public String getSoundStatus(){
        return loading;
    }

    public void run(){
        loading="1 of 4";
        startupSound=applet.getAudioClip(codeBase, "startup8k.au");
		startupSound.play();
		startupSound.stop();
        loading="2 of 4";
        idleSound=applet.getAudioClip(codeBase, "idle8k.au");
		idleSound.play();
		idleSound.stop();
        loading="3 of 4";
        revSound=applet.getAudioClip(codeBase, "revup8k.au");
		revSound.play();
		revSound.stop();
		loading="4 of 4";
        burnoutSound=applet.getAudioClip(codeBase, "burnout8k.au");
		burnoutSound.play();
		burnoutSound.stop();
		loading="finished";
        while(true){
            if(System.currentTimeMillis()>waitFor){
                playIdle=true;
                waitFor=System.currentTimeMillis()*2;
            }
            while(playIdle){
                idleSound.loop();
                try{sleep(idleSoundLength);}
                catch(InterruptedException e){}
            }
            try{sleep(100);}
            catch (InterruptedException e){}
        }
    }

    private void setParameters(){
    	if(applet.getParameter("burnoutSoundLength")!=null) burnoutSoundLength=Integer.parseInt(applet.getParameter("burnoutSoundLength"));
    	if(applet.getParameter("startupSoundLength")!=null) startupSoundLength=Integer.parseInt(applet.getParameter("startupSoundLength"));
    	if(applet.getParameter("idleSoundLength")!=null) idleSoundLength=Integer.parseInt(applet.getParameter("idleSoundLength"));
    	if(applet.getParameter("revSoundLength")!=null) revSoundLength=Integer.parseInt(applet.getParameter("revSoundLength"));
    }

}
